Index: extended.cpp
===================================================================
--- extended.cpp	(révision 23468)
+++ extended.cpp	(copie de travail)
@@ -61,7 +61,7 @@
     layout->addWidget( mainTab, 0, 0, 1, 5 );
 
     QPushButton *closeButton = new QPushButton( qtr( "Close" ) );
-    layout->addWidget( closeButton, 1, 4, 1, 1);
+    layout->addWidget( closeButton, 1, 4, 1, 1 );
     CONNECT( closeButton, clicked(), this, close() );
 
     readSettings( "EPanel", QSize( 400, 300 ), QPoint( 450, 0 ) );
Index: gototime.cpp
===================================================================
--- gototime.cpp	(révision 23468)
+++ gototime.cpp	(copie de travail)
@@ -66,11 +66,11 @@
     QLabel *helpFormat = new QLabel( timeEdit->displayFormat() );
     helpFormat->setSizePolicy( QSizePolicy::Minimum, QSizePolicy::Preferred );
 
-    QSpacerItem *spacerBox = new QSpacerItem(20, 10, QSizePolicy::Minimum,
-                                        QSizePolicy::Fixed);
+    QSpacerItem *spacerBox = new QSpacerItem( 20, 10, QSizePolicy::Minimum,
+                                        QSizePolicy::Fixed );
 
-    QSpacerItem *spacerItem = new QSpacerItem(20, 3, QSizePolicy::Minimum,
-                                        QSizePolicy::Expanding);
+    QSpacerItem *spacerItem = new QSpacerItem( 20, 3, QSizePolicy::Minimum,
+                                        QSizePolicy::Expanding );
 
     boxLayout->addWidget( timeIntro, 0, 0, 1, 2 );
     boxLayout->addItem( spacerBox, 1, 0, 1, 2 );
Index: gototime.hpp
===================================================================
--- gototime.hpp	(révision 23468)
+++ gototime.hpp	(copie de travail)
@@ -35,13 +35,13 @@
     static GotoTimeDialog * getInstance( intf_thread_t *p_intf )
     {
         if( !instance)
-            instance = new GotoTimeDialog( p_intf);
+            instance = new GotoTimeDialog( p_intf );
         return instance;
     }
     virtual ~GotoTimeDialog();
 
 private:
-    GotoTimeDialog( intf_thread_t *);
+    GotoTimeDialog( intf_thread_t * );
     static GotoTimeDialog *instance;
     QTimeEdit *timeEdit;
 private slots:
Index: interaction.cpp
===================================================================
--- interaction.cpp	(révision 23468)
+++ interaction.cpp	(copie de travail)
@@ -109,7 +109,7 @@
         progressBar = new QProgressBar;
         progressBar->setMaximum( 1000 );
         progressBar->setTextVisible( true );
-        progressBar->setOrientation(Qt::Horizontal);
+        progressBar->setOrientation( Qt::Horizontal );
         layout->addWidget( progressBar );
     }
     else if( p_dialog->i_flags & DIALOG_PSZ_INPUT_OK_CANCEL )
@@ -174,7 +174,7 @@
     {
         assert( progressBar );
         progressBar->setValue( (int)(p_dialog->val.f_float*1000) );
-        msg_Dbg( p_intf, "Setting progress to %i\n", progressBar->value() );
+        msg_Dbg( p_intf, "Setting progress to %i", progressBar->value() );
     }
 }
 
Index: messages.cpp
===================================================================
--- messages.cpp	(révision 23468)
+++ messages.cpp	(copie de travail)
@@ -60,9 +60,9 @@
     messages->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
 
     layout->addWidget( messages, 0, 0, 1, 0 );
-    layout->addWidget( verbosityLabel, 1, 0, 1,1 );
+    layout->addWidget( verbosityLabel, 1, 0, 1, 1 );
     layout->addWidget( verbosityBox, 1, 1 );
-    layout->addItem( new QSpacerItem( 20, 20, QSizePolicy::Expanding ), 1,2 );
+    layout->addItem( new QSpacerItem( 20, 20, QSizePolicy::Expanding ), 1, 2 );
     layout->addWidget( saveLogButton, 1, 3 );
     layout->addWidget( clearButton, 1, 4 );
     layout->addWidget( closeButton, 1, 5 );
@@ -103,7 +103,7 @@
             {
                 messages->setFontItalic( true );
                 messages->setTextColor( "darkBlue" );
-                messages->insertPlainText( qfu(p_sub->p_msg[i_start].psz_module));
+                messages->insertPlainText( qfu( p_sub->p_msg[i_start].psz_module ) );
             }
             else
                 continue;
Index: messages.hpp
===================================================================
--- messages.hpp	(révision 23468)
+++ messages.hpp	(copie de travail)
@@ -39,13 +39,13 @@
     static MessagesDialog * getInstance( intf_thread_t *p_intf )
     {
         if( !instance)
-            instance = new MessagesDialog( p_intf);
+            instance = new MessagesDialog( p_intf );
         return instance;
     }
     virtual ~MessagesDialog();
 
 private:
-    MessagesDialog( intf_thread_t *);
+    MessagesDialog( intf_thread_t * );
     static MessagesDialog *instance;
     QSpinBox *verbosityBox;
     QTextEdit *messages;
Index: open.cpp
===================================================================
--- open.cpp	(révision 23468)
+++ open.cpp	(copie de travail)
@@ -70,8 +70,8 @@
 
     /* Buttons Creation */
     QSizePolicy buttonSizePolicy( QSizePolicy::Expanding, QSizePolicy::Minimum );
-    buttonSizePolicy.setHorizontalStretch(0);
-    buttonSizePolicy.setVerticalStretch(0);
+    buttonSizePolicy.setHorizontalStretch( 0 );
+    buttonSizePolicy.setVerticalStretch( 0 );
 
     /* Play Button */
     playButton = new QToolButton( this );
@@ -88,13 +88,13 @@
 
     /* Menu for the Play button */
     QMenu * openButtonMenu = new QMenu( "Open" );
-    openButtonMenu->addAction( qtr("&Enqueue"), this, SLOT( enqueue() ),
+    openButtonMenu->addAction( qtr( "&Enqueue" ), this, SLOT( enqueue() ),
                                     QKeySequence( "Alt+E") );
-    openButtonMenu->addAction( qtr("&Play"), this, SLOT( play() ),
+    openButtonMenu->addAction( qtr( "&Play" ), this, SLOT( play() ),
                                     QKeySequence( "Alt+P" ) );
-    openButtonMenu->addAction( qtr("&Stream"), this, SLOT( stream() ) ,
+    openButtonMenu->addAction( qtr( "&Stream" ), this, SLOT( stream() ) ,
                                     QKeySequence( "Alt+S" ) );
-    openButtonMenu->addAction( qtr("&Convert"), this, SLOT( transcode() ) ,
+    openButtonMenu->addAction( qtr( "&Convert" ), this, SLOT( transcode() ) ,
                                     QKeySequence( "Alt+C" ) );
 
     playButton->setMenu( openButtonMenu );
@@ -103,7 +103,7 @@
     ui.buttonsBox->addButton( cancelButton, QDialogButtonBox::RejectRole );
 
     /* Force MRL update on tab change */
-    CONNECT( ui.Tab, currentChanged(int), this, signalCurrent());
+    CONNECT( ui.Tab, currentChanged(int), this, signalCurrent() );
 
     CONNECT( fileOpenPanel, mrlUpdated( QString ), this, updateMRL(QString) );
     CONNECT( netOpenPanel, mrlUpdated( QString ), this, updateMRL(QString) );
@@ -120,21 +120,21 @@
                                                  this, newCachingMethod(QString) );
 
     /* Advanced frame Connects */
-    CONNECT( ui.slaveText, textChanged(QString), this, updateMRL());
-    CONNECT( ui.cacheSpinBox, valueChanged(int), this, updateMRL());
-    CONNECT( ui.startTimeSpinBox, valueChanged(int), this, updateMRL());
+    CONNECT( ui.slaveText, textChanged(QString), this, updateMRL() );
+    CONNECT( ui.cacheSpinBox, valueChanged(int), this, updateMRL() );
+    CONNECT( ui.startTimeSpinBox, valueChanged(int), this, updateMRL() );
     BUTTONACT( ui.advancedCheckBox , toggleAdvancedPanel() );
 
     /* Buttons action */
-    BUTTONACT( playButton, selectSlots());
-    BUTTONACT( cancelButton, cancel());
+    BUTTONACT( playButton, selectSlots() );
+    BUTTONACT( cancelButton, cancel() );
 
     /* At creation time, modify the default buttons */
     if ( i_action_flag ) setMenuAction();
 
     /* Initialize caching */
     storedMethod = "";
-    newCachingMethod("file-caching");
+    newCachingMethod( "file-caching" );
 
     mainHeight = advHeight = 0;
 }
@@ -149,17 +149,17 @@
     switch ( i_action_flag )
     {
     case OPEN_AND_STREAM:
-        playButton->setText( qtr("&Stream") );
+        playButton->setText( qtr( "&Stream" ) );
         break;
     case OPEN_AND_SAVE:
-        playButton->setText( qtr("&Convert / Save") );
+        playButton->setText( qtr( "&Convert / Save" ) );
         break;
     case OPEN_AND_ENQUEUE:
-        playButton->setText( qtr("&Enqueue") );
+        playButton->setText( qtr( "&Enqueue" ) );
         break;
     case OPEN_AND_PLAY:
     default:
-        playButton->setText( qtr("&Play") );
+        playButton->setText( qtr( "&Play" ) );
    }
 }
 
@@ -180,7 +180,7 @@
     if( ui.advancedFrame->isVisible() ) {
         ui.advancedFrame->hide();
 #ifndef WIN32
-        setMinimumHeight(1);
+        setMinimumHeight( 1 );
         resize( width(), mainHeight );
 #endif
     } else {
@@ -322,16 +322,16 @@
     if( ui.slaveCheckbox->isChecked() ) {
         mrl += " :input-slave=" + ui.slaveText->text();
     }
-    int i_cache = config_GetInt( p_intf, qta(storedMethod) );
+    int i_cache = config_GetInt( p_intf, qta( storedMethod ) );
     if( i_cache != ui.cacheSpinBox->value() ) {
-        mrl += QString(" :%1=%2").arg(storedMethod).
-                                  arg(ui.cacheSpinBox->value());
+        mrl += QString( " :%1=%2" ).arg( storedMethod ).
+                                  arg( ui.cacheSpinBox->value() );
     }
-    if( ui.startTimeSpinBox->value()) {
-        mrl += " :start-time=" + QString("%1").
-            arg(ui.startTimeSpinBox->value());
+    if( ui.startTimeSpinBox->value() ) {
+        mrl += " :start-time=" + QString( "%1" ).
+            arg( ui.startTimeSpinBox->value() );
     }
-    ui.advancedLineInput->setText(mrl);
+    ui.advancedLineInput->setText( mrl );
 }
 
 void OpenDialog::newCachingMethod( QString method )
Index: open.hpp
===================================================================
--- open.hpp	(révision 23468)
+++ open.hpp	(copie de travail)
@@ -42,7 +42,7 @@
     static OpenDialog * getInstance( QWidget *parent, intf_thread_t *p_intf,
                  int _action_flag = 0 )
     {
-        if( !instance)
+        if( !instance )
             instance = new OpenDialog( parent, p_intf, false, _action_flag );
         else
         {
Index: playlist.cpp
===================================================================
--- playlist.cpp	(révision 23468)
+++ playlist.cpp	(copie de travail)
@@ -57,7 +57,7 @@
     writeSettings( "playlist" );
 }
 
-void PlaylistDialog::dropEvent(QDropEvent *event)
+void PlaylistDialog::dropEvent( QDropEvent *event )
 {
      const QMimeData *mimeData = event->mimeData();
      foreach( QUrl url, mimeData->urls() ) {
@@ -69,15 +69,15 @@
      }
      event->acceptProposedAction();
 }
-void PlaylistDialog::dragEnterEvent(QDragEnterEvent *event)
+void PlaylistDialog::dragEnterEvent( QDragEnterEvent *event )
 {
      event->acceptProposedAction();
 }
-void PlaylistDialog::dragMoveEvent(QDragMoveEvent *event)
+void PlaylistDialog::dragMoveEvent( QDragMoveEvent *event )
 {
      event->acceptProposedAction();
 }
-void PlaylistDialog::dragLeaveEvent(QDragLeaveEvent *event)
+void PlaylistDialog::dragLeaveEvent( QDragLeaveEvent *event )
 {
      event->accept();
 }
Index: podcast_configuration.hpp
===================================================================
--- podcast_configuration.hpp	(révision 23468)
+++ podcast_configuration.hpp	(copie de travail)
@@ -33,14 +33,14 @@
 public:
     static PodcastConfigDialog * getInstance( intf_thread_t *p_intf )
     {
-        if( !instance)
+        if( !instance )
             instance = new PodcastConfigDialog( p_intf );
         return instance;
     }
     virtual ~PodcastConfigDialog();
 
 private:
-    PodcastConfigDialog( intf_thread_t *);
+    PodcastConfigDialog( intf_thread_t * );
     static PodcastConfigDialog *instance;
     Ui::PodcastConfiguration ui;
 public slots:
Index: preferences.cpp
===================================================================
--- preferences.cpp	(révision 23468)
+++ preferences.cpp	(copie de travail)
@@ -92,7 +92,7 @@
     main_layout->setColumnStretch( 0, 1 );
     main_layout->setColumnStretch( 1, 3 );
 
-    main_layout->setRowStretch( 2, 4);
+    main_layout->setRowStretch( 2, 4 );
 
     setLayout( main_layout );
 
@@ -102,7 +102,7 @@
 
     for( int i = 0; i < SPrefsMax ; i++ ) simple_panels[i] = NULL;
 
-    if( config_GetInt( p_intf, "qt-advanced-pref") == 1 )
+    if( config_GetInt( p_intf, "qt-advanced-pref" ) == 1 )
         setAdvanced();
     else
         setSmall();
@@ -128,7 +128,7 @@
          advanced_tree = new PrefsTree( p_intf, tree_panel );
         /* and connections */
          CONNECT( advanced_tree,
-                  currentItemChanged( QTreeWidgetItem *, QTreeWidgetItem *),
+                  currentItemChanged( QTreeWidgetItem *, QTreeWidgetItem * ),
                   this, changeAdvPanel( QTreeWidgetItem * ) );
         tree_panel_l->addWidget( advanced_tree );
     }
@@ -137,7 +137,7 @@
     advanced_tree->show();
 
     /* Remove the simple current panel from the main panels*/
-    if( current_simple_panel  )
+    if( current_simple_panel )
         if( current_simple_panel->isVisible() ) current_simple_panel->hide();
 
     /* If no advanced Panel exist, create one, attach it and show it*/
@@ -174,11 +174,11 @@
     if( advanced_panel )
         if( advanced_panel->isVisible() ) advanced_panel->hide();
 
-    if( !current_simple_panel  )
+    if( !current_simple_panel )
     {
-        current_simple_panel  = new SPrefsPanel( p_intf, main_panel, SPrefsDefaultCat );
+        current_simple_panel = new SPrefsPanel( p_intf, main_panel, SPrefsDefaultCat );
         simple_panels[SPrefsDefaultCat] =  current_simple_panel;
-        main_panel_l->addWidget( current_simple_panel  );
+        main_panel_l->addWidget( current_simple_panel );
     }
 
     current_simple_panel->show();
@@ -188,15 +188,15 @@
 /* Switching from on simple panel to another */
 void PrefsDialog::changeSimplePanel( int number )
 {
-    if( current_simple_panel  )
+    if( current_simple_panel )
         if( current_simple_panel->isVisible() ) current_simple_panel->hide();
 
     current_simple_panel = simple_panels[number];
-    if( !current_simple_panel  )
+    if( !current_simple_panel )
     {
         current_simple_panel  = new SPrefsPanel( p_intf, main_panel, number );
         simple_panels[number] = current_simple_panel;
-        main_panel_l->addWidget( current_simple_panel  );
+        main_panel_l->addWidget( current_simple_panel );
     }
 
     current_simple_panel->show();
@@ -285,7 +285,7 @@
         advanced_tree->cleanAll();
         advanced_panel = NULL;
     }
-    if( all->isChecked() && current_simple_panel  )
+    if( all->isChecked() && current_simple_panel )
     {
         for( int i = 0 ; i< SPrefsMax; i++ )
         {
@@ -320,12 +320,12 @@
 /* Reset all the preferences, when you click the button */
 void PrefsDialog::reset()
 {
-    int ret = QMessageBox::question(this, qtr("Reset Preferences"),
-                 qtr("This will reset your VLC media player preferences.\n"
-                         "Are you sure you want to continue?"),
+    int ret = QMessageBox::question(this, qtr( "Reset Preferences" ),
+                 qtr( "This will reset your VLC media player preferences.\n"
+                         "Are you sure you want to continue?" ),
                   QMessageBox::Ok | QMessageBox::Cancel,
                                                          QMessageBox::Ok);
-    if ( ret == QMessageBox::Ok )
+    if( ret == QMessageBox::Ok )
     {
         config_ResetAll( p_intf );
         config_SaveConfigFile( p_intf, NULL );
Index: sout.cpp
===================================================================
--- sout.cpp	(révision 23468)
+++ sout.cpp	(copie de travail)
@@ -177,7 +177,7 @@
 
 void SoutDialog::setRawOptions( bool b_raw )
 {
-    if ( b_raw )
+    if( b_raw )
     {
         ui.tabWidget->setDisabled( true );
     }
Index: vlm.cpp
===================================================================
--- vlm.cpp	(révision 23468)
+++ vlm.cpp	(copie de travail)
@@ -77,8 +77,8 @@
 
     layout->addWidget( slayout );
 
-    QPushButton *closeButton = new QPushButton( qtr("Close") );
-    QPushButton *cancelButton = new QPushButton( qtr("Cancel") );
+    QPushButton *closeButton = new QPushButton( qtr( "Close" ) );
+    QPushButton *cancelButton = new QPushButton( qtr( "Cancel" ) );
     ui.buttonBox->addButton( closeButton, QDialogButtonBox::AcceptRole );
     ui.buttonBox->addButton( cancelButton, QDialogButtonBox::RejectRole );
 
@@ -94,87 +94,87 @@
 {
     pBcast = new QWidget( ui.groupBox );
     bcastlayout = new QGridLayout( pBcast );
-    bcastname = new QLabel( qtr( "Name :" ),pBcast );
+    bcastname = new QLabel( qtr( "Name :" ), pBcast );
     bcastnameledit = new QLineEdit( pBcast );
-    bcastenable = new QCheckBox( qtr( "Enable" ),pBcast );
-    bcastinput = new QLabel( qtr( "Input :" ),pBcast );
+    bcastenable = new QCheckBox( qtr( "Enable" ), pBcast );
+    bcastinput = new QLabel( qtr( "Input :" ), pBcast );
     bcastinputledit = new QLineEdit( pBcast );
     bcastinputtbutton = new QToolButton( pBcast );
-    bcastoutput = new QLabel( qtr( "Output :" ),pBcast );
+    bcastoutput = new QLabel( qtr( "Output :" ), pBcast );
     bcastoutputledit = new QLineEdit( pBcast );
     bcastoutputtbutton = new QToolButton( pBcast );
-    bcastcontrol = new QGroupBox( qtr( "Controls" ),pBcast );
+    bcastcontrol = new QGroupBox( qtr( "Controls" ), pBcast );
     bcastgbox = new QHBoxLayout( bcastcontrol );
-    bcastplay = new QPushButton( qtr( "Play" ),bcastcontrol );
-    bcastpause = new QPushButton( qtr( "Pause" ),bcastcontrol );
-    bcaststop = new QPushButton( qtr( "Stop" ),bcastcontrol );
-    bcastadd = new QPushButton( qtr( "Add" ),pBcast );
-    bcastremove = new QPushButton( qtr( "Remove" ),pBcast );
+    bcastplay = new QPushButton( qtr( "Play" ), bcastcontrol );
+    bcastpause = new QPushButton( qtr( "Pause" ), bcastcontrol );
+    bcaststop = new QPushButton( qtr( "Stop" ), bcastcontrol );
+    bcastadd = new QPushButton( qtr( "Add" ), pBcast );
+    bcastremove = new QPushButton( qtr( "Remove" ), pBcast );
 
 // Adding all widgets in the QGridLayout
     bcastgbox->addWidget( bcastplay );
     bcastgbox->addWidget( bcastpause );
     bcastgbox->addWidget( bcaststop );
-    bcastlayout->addWidget( bcastname,0,0 );
-    bcastlayout->addWidget( bcastnameledit,0,1 );
-    bcastlayout->addWidget( bcastenable,0,2 );
-    bcastlayout->addWidget( bcastinput,1,0 );
-    bcastlayout->addWidget( bcastinputledit,1,1 );
-    bcastlayout->addWidget( bcastinputtbutton,1,2 );
-    bcastlayout->addWidget( bcastoutput,2,0 );
-    bcastlayout->addWidget( bcastoutputledit,2,1 );
-    bcastlayout->addWidget( bcastoutputtbutton,2,2 );
-    bcastlayout->addWidget( bcastcontrol,3,0,1,3 );
-    bcastlayout->addWidget( bcastadd,4,1 );
-    bcastlayout->addWidget( bcastremove,4,2 );
+    bcastlayout->addWidget( bcastname, 0, 0 );
+    bcastlayout->addWidget( bcastnameledit, 0, 1 );
+    bcastlayout->addWidget( bcastenable, 0, 2 );
+    bcastlayout->addWidget( bcastinput, 1, 0 );
+    bcastlayout->addWidget( bcastinputledit, 1, 1 );
+    bcastlayout->addWidget( bcastinputtbutton, 1, 2 );
+    bcastlayout->addWidget( bcastoutput, 2, 0 );
+    bcastlayout->addWidget( bcastoutputledit, 2, 1 );
+    bcastlayout->addWidget( bcastoutputtbutton, 2, 2 );
+    bcastlayout->addWidget( bcastcontrol, 3, 0, 1, 3 );
+    bcastlayout->addWidget( bcastadd, 4, 1 );
+    bcastlayout->addWidget( bcastremove, 4, 2 );
 }
 
 void VLMDialog::makeVODPage()
 {
     pVod = new QWidget( ui.groupBox );
     vodlayout = new QGridLayout( pVod );
-    vodname = new QLabel( qtr( "Name :" ),pVod );
+    vodname = new QLabel( qtr( "Name :" ), pVod );
     vodnameledit = new QLineEdit( pVod );
-    vodenable = new QCheckBox( qtr( "Enable" ),pVod );
-    vodinput = new QLabel( qtr( "Input :" ),pVod );
+    vodenable = new QCheckBox( qtr( "Enable" ), pVod );
+    vodinput = new QLabel( qtr( "Input :" ), pVod );
     vodinputledit = new QLineEdit( pVod );
     vodinputtbutton = new QToolButton( pVod );
-    vodoutput = new QLabel( qtr( "Output :" ),pVod );
+    vodoutput = new QLabel( qtr( "Output :" ), pVod );
     vodoutputledit = new QLineEdit( pVod );
     vodoutputtbutton = new QToolButton( pVod );
-    vodadd = new QPushButton( qtr( "Add" ),pVod );
-    vodremove = new QPushButton( qtr( "Remove" ),pVod );
+    vodadd = new QPushButton( qtr( "Add" ), pVod );
+    vodremove = new QPushButton( qtr( "Remove" ), pVod );
 
 // Adding all widgets in the QGridLayout
-    vodlayout->addWidget( vodname,0,0 );
-    vodlayout->addWidget( vodnameledit,0,1 );
-    vodlayout->addWidget( vodenable,0,2 );
-    vodlayout->addWidget( vodinput,1,0 );
-    vodlayout->addWidget( vodinputledit,1,1 );
-    vodlayout->addWidget( vodinputtbutton,1,2 );
-    vodlayout->addWidget( vodoutput,2,0 );
-    vodlayout->addWidget( vodoutputledit,2,1 );
-    vodlayout->addWidget( vodoutputtbutton,2,2 );
-    vodlayout->addWidget( vodadd,3,1 );
-    vodlayout->addWidget( vodremove,3,2 );
+    vodlayout->addWidget( vodname, 0, 0 );
+    vodlayout->addWidget( vodnameledit, 0, 1 );
+    vodlayout->addWidget( vodenable, 0, 2 );
+    vodlayout->addWidget( vodinput, 1, 0 );
+    vodlayout->addWidget( vodinputledit, 1, 1 );
+    vodlayout->addWidget( vodinputtbutton, 1, 2 );
+    vodlayout->addWidget( vodoutput, 2, 0 );
+    vodlayout->addWidget( vodoutputledit, 2, 1 );
+    vodlayout->addWidget( vodoutputtbutton, 2, 2 );
+    vodlayout->addWidget( vodadd, 3, 1 );
+    vodlayout->addWidget( vodremove, 3, 2 );
 }
 
 void VLMDialog::makeSchedulePage()
 {
     pSchedule = new QWidget( ui.groupBox );
     schelayout = new QGridLayout( pSchedule );
-    schename = new QLabel( qtr( "Name :" ),pSchedule );
+    schename = new QLabel( qtr( "Name :" ), pSchedule );
     schenameledit = new QLineEdit( pSchedule );
-    scheenable = new QCheckBox( qtr( "Enable" ),pSchedule );
-    scheinput = new QLabel( qtr( "Input :" ),pSchedule );
+    scheenable = new QCheckBox( qtr( "Enable" ), pSchedule );
+    scheinput = new QLabel( qtr( "Input :" ), pSchedule );
     scheinputledit = new QLineEdit( pSchedule );
     scheinputtbutton = new QToolButton( pSchedule );
-    scheoutput = new QLabel( qtr( "Output :" ),pSchedule );
+    scheoutput = new QLabel( qtr( "Output :" ), pSchedule );
     scheoutputledit = new QLineEdit( pSchedule );
     scheoutputtbutton = new QToolButton( pSchedule );
-    schecontrol = new QGroupBox( qtr( "Time Control" ),pSchedule );
-    scheadd = new QPushButton( qtr( "Add" ),pSchedule );
-    scheremove = new QPushButton( qtr( "Remove" ),pSchedule );
+    schecontrol = new QGroupBox( qtr( "Time Control" ), pSchedule );
+    scheadd = new QPushButton( qtr( "Add" ), pSchedule );
+    scheremove = new QPushButton( qtr( "Remove" ), pSchedule );
     schetimelayout = new QGridLayout( schecontrol );
     schetimelabel = new QLabel( qtr( "Hours/Minutes/Seconds :" ), schecontrol );
     schedatelabel = new QLabel( qtr( "Day/Month/Year :" ), schecontrol );
@@ -186,23 +186,23 @@
     //scheadd->setMaximumWidth( 30 );
 
 // Adding all widgets in the QGridLayout
-    schetimelayout->addWidget( schetimelabel,0,0 );
-    schetimelayout->addWidget( time,0,1 );
-    schetimelayout->addWidget( schedatelabel,1,0 );
-    schetimelayout->addWidget( date,1,1 );
-    schetimelayout->addWidget( schetimerepeat,2,0 );
-    schetimelayout->addWidget( scherepeatnumber,2,1 );
-    schelayout->addWidget( schename,0,0 );
-    schelayout->addWidget( schenameledit,0,1 );
-    schelayout->addWidget( scheenable,0,2 );
-    schelayout->addWidget( scheinput,1,0 );
-    schelayout->addWidget( scheinputledit,1,1 );
-    schelayout->addWidget( scheinputtbutton,1,2 );
-    schelayout->addWidget( scheoutput,2,0 );
-    schelayout->addWidget( scheoutputledit,2,1 );
-    schelayout->addWidget( scheoutputtbutton,2,2 );
-    schelayout->addWidget( schecontrol,3,0,1,3 );
-    schelayout->addWidget( scheadd,4,1 );
-    schelayout->addWidget( scheremove,4,2 );
+    schetimelayout->addWidget( schetimelabel, 0, 0 );
+    schetimelayout->addWidget( time, 0, 1 );
+    schetimelayout->addWidget( schedatelabel, 1, 0 );
+    schetimelayout->addWidget( date, 1, 1 );
+    schetimelayout->addWidget( schetimerepeat, 2, 0 );
+    schetimelayout->addWidget( scherepeatnumber, 2, 1 );
+    schelayout->addWidget( schename, 0, 0 );
+    schelayout->addWidget( schenameledit, 0, 1 );
+    schelayout->addWidget( scheenable, 0, 2 );
+    schelayout->addWidget( scheinput, 1, 0 );
+    schelayout->addWidget( scheinputledit, 1, 1 );
+    schelayout->addWidget( scheinputtbutton, 1, 2 );
+    schelayout->addWidget( scheoutput, 2, 0 );
+    schelayout->addWidget( scheoutputledit, 2, 1 );
+    schelayout->addWidget( scheoutputtbutton, 2, 2 );
+    schelayout->addWidget( schecontrol, 3, 0, 1, 3 );
+    schelayout->addWidget( scheadd, 4, 1 );
+    schelayout->addWidget( scheremove, 4, 2 );
 }
 
Index: vlm.hpp
===================================================================
--- vlm.hpp	(révision 23468)
+++ vlm.hpp	(copie de travail)
@@ -59,7 +59,7 @@
     virtual ~VLMDialog();
 
 private:
-    VLMDialog( intf_thread_t *);
+    VLMDialog( intf_thread_t * );
     static VLMDialog *instance;
     Ui::Vlm ui;
 