Index: include/vlc_configuration.h
===================================================================
--- include/vlc_configuration.h	(Revision 25377)
+++ include/vlc_configuration.h	(Arbeitskopie)
@@ -169,6 +169,7 @@
     int         *pi_list;                              /* Idem for integers */
     char       **ppsz_list_text;          /* Friendly names for list values */
     int          i_list;                               /* Options list size */
+    vlc_callback_t pf_update_list;
 
     /* Actions list */
     vlc_callback_t *ppf_action;    /* List of possible actions for a config */
@@ -435,19 +436,22 @@
     vlc_config_set (p_config, VLC_CONFIG_LIST, \
                     (size_t)(sizeof (list) / sizeof (char *)), \
                     (const char *const *)(list), \
-                    (const char *const *)(list_text))
+                    (const char *const *)(list_text), \
+                    list_update_func)
 
 #define change_integer_list( list, list_text, list_update_func ) \
     vlc_config_set (p_config, VLC_CONFIG_LIST, \
                     (size_t)(sizeof (list) / sizeof (int)), \
                     (const int *)(list), \
-                    (const char *const *)(list_text))
+                    (const char *const *)(list_text), \
+                    list_update_func)
 
 #define change_float_list( list, list_text, list_update_func ) \
     vlc_config_set (p_config, VLC_CONFIG_LIST, \
                     (size_t)(sizeof (list) / sizeof (float)), \
                     (const float *)(list), \
-                    (const char *const *)(list_text))
+                    (const char *const *)(list_text), \
+                    list_update_func)
 
 #define change_integer_range( minv, maxv ) \
     vlc_config_set (p_config, VLC_CONFIG_RANGE, (int)(minv), (int)(maxv))
Index: src/modules/entry.c
===================================================================
--- src/modules/entry.c	(Revision 25377)
+++ src/modules/entry.c	(Arbeitskopie)
@@ -368,6 +368,7 @@
             }
 
             item->i_list = len;
+            item->pf_update_list = va_arg (ap, vlc_callback_t);
             ret = 0;
             break;
         }
Index: modules/gui/qt4/components/preferences_widgets.cpp
===================================================================
--- modules/gui/qt4/components/preferences_widgets.cpp	(Revision 25382)
+++ modules/gui/qt4/components/preferences_widgets.cpp	(Arbeitskopie)
@@ -374,6 +374,20 @@
     combo->setSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::Preferred );
 
     module_config_t *p_module_config = config_FindConfig( p_this, getName() );
+    if(p_item->pf_update_list) 
+    {
+       vlc_value_t val;
+       val.psz_string = strdup(p_item->value.psz);
+       
+       p_item->pf_update_list(p_this, getName(), val, val, NULL);
+
+       // assume in a×y case that dirty was set to VLC_TRUE
+       // because lazy programmes will use the same callback for
+       // this, like the one behind the refresh push button?
+       p_item->b_dirty = VLC_FALSE;
+
+       if(val.psz_string) free(val.psz_string);
+    }
 
     finish( p_module_config, bycat );
     if( !l )
@@ -473,6 +487,17 @@
                       config_FindConfig( VLC_OBJECT(p_intf), configname );
     if( p_config )
     {
+       if(p_config->pf_update_list) 
+        {
+            vlc_value_t val;
+            val.i_int = p_config->value.i;
+            p_config->pf_update_list(VLC_OBJECT(p_intf), configname, val, val, NULL);
+            // assume in any case that dirty was set to VLC_TRUE
+            // because lazy programmes will use the same callback for
+            // this, like the one behind the refresh push button?
+            p_config->b_dirty = VLC_FALSE;
+        }
+
         for ( int i_index = 0; i_index < p_config->i_list; i_index++ )
         {
             combo->addItem( qfu( p_config->ppsz_list_text[i_index] ),
@@ -838,7 +863,20 @@
     combo->setMinimumWidth( MINWIDTH_BOX );
 
     module_config_t *p_module_config = config_FindConfig( p_this, getName() );
+    if(p_module_config->pf_update_list) 
+    {
+       vlc_value_t val;
+       val.i_int = p_module_config->value.i;
+       
+       p_module_config->pf_update_list(p_this, getName(), val, val, NULL);
+
+       // assume in any case that dirty was set to VLC_TRUE
+       // because lazy programmes will use the same callback for
+       // this, like the one behind the refresh push button?
+       p_module_config->b_dirty = VLC_FALSE;
+    }
 
+
     finish( p_module_config, bycat );
     if( !l )
     {