Index: encoder/set.h
===================================================================
--- encoder/set.h	(revision 745)
+++ encoder/set.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _ENCODER_SET_H
-#define _ENCODER_SET_H 1
+#ifndef X264_ENCODER_SET_H
+#define X264_ENCODER_SET_H
 
 void x264_sps_init( x264_sps_t *sps, int i_id, x264_param_t *param );
 void x264_sps_write( bs_t *s, x264_sps_t *sps );
Index: encoder/ratecontrol.h
===================================================================
--- encoder/ratecontrol.h	(revision 745)
+++ encoder/ratecontrol.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _RATECONTROL_H
-#define _RATECONTROL_H 1
+#ifndef X264_RATECONTROL_H
+#define X264_RATECONTROL_H
 
 int  x264_ratecontrol_new   ( x264_t * );
 void x264_ratecontrol_delete( x264_t * );
Index: encoder/analyse.h
===================================================================
--- encoder/analyse.h	(revision 745)
+++ encoder/analyse.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _ANALYSE_H
-#define _ANALYSE_H 1
+#ifndef X264_ANALYSE_H
+#define X264_ANALYSE_H
 
 void x264_macroblock_analyse( x264_t *h );
 void x264_slicetype_decide( x264_t *h );
Index: encoder/me.h
===================================================================
--- encoder/me.h	(revision 745)
+++ encoder/me.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _ME_H
-#define _ME_H 1
+#ifndef X264_ME_H
+#define X264_ME_H
 
 #define COST_MAX (1<<28)
 
Index: encoder/macroblock.h
===================================================================
--- encoder/macroblock.h	(revision 745)
+++ encoder/macroblock.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _ENCODER_MACROBLOCK_H
-#define _ENCODER_MACROBLOCK_H 1
+#ifndef X264_ENCODER_MACROBLOCK_H
+#define X264_ENCODER_MACROBLOCK_H
 
 #include "common/macroblock.h"
 
Index: gtk/x264_gtk_more.h
===================================================================
--- gtk/x264_gtk_more.h	(revision 745)
+++ gtk/x264_gtk_more.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_MORE_H__
-#define __X264_GTK_MORE_H__
+#ifndef X264_GTK_MORE_H
+#define X264_GTK_MORE_H
 
 
 GtkWidget *_more_page (X264_Gui_Config *config);
 
 
-#endif /* __X264_GTK_MORE_H__ */
+#endif /* X264_GTK_MORE_H */
Index: gtk/x264_gtk_enum.h
===================================================================
--- gtk/x264_gtk_enum.h	(revision 745)
+++ gtk/x264_gtk_enum.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef __X264_GTK_ENUM_H__
-#define __X264_GTK_ENUM_H__
+#ifndef X264_GTK_ENUM_H
+#define X264_GTK_ENUM_H
 
 typedef enum
 {
@@ -54,4 +54,4 @@
 }X264_Cqm_Preset;
 
 
-#endif /* __X264_GTK_ENUM_H__ */
+#endif /* X264_GTK_ENUM_H */
Index: gtk/x264_gtk_rc.h
===================================================================
--- gtk/x264_gtk_rc.h	(revision 745)
+++ gtk/x264_gtk_rc.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_RC_H__
-#define __X264_GTK_RC_H__
+#ifndef X264_GTK_RC_H
+#define X264_GTK_RC_H
 
 
 GtkWidget *_rate_control_page (X264_Gui_Config *config);
 
 
-#endif /* __X264_GTK_RC_H__ */
+#endif /* X264_GTK_RC_H */
Index: gtk/x264_gtk_encode_encode.h
===================================================================
--- gtk/x264_gtk_encode_encode.h	(revision 745)
+++ gtk/x264_gtk_encode_encode.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_ENCODE_ENCODE_H__
-#define __X264_GTK_ENCODE_ENCODE_H__
+#ifndef X264_GTK_ENCODE_ENCODE_H
+#define X264_GTK_ENCODE_ENCODE_H
 
 
 gpointer x264_gtk_encode_encode (X264_Thread_Data *thread_data);
 
 
-#endif /* __X264_GTK_ENCODE_ENCODE_H__ */
+#endif /* X264_GTK_ENCODE_ENCODE_H */
Index: gtk/x264_gtk_private.h
===================================================================
--- gtk/x264_gtk_private.h	(revision 745)
+++ gtk/x264_gtk_private.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef __X264_GTK_PRIVATE_H__
-#define __X264_GTK_PRIVATE_H__
+#ifndef X264_GTK_PRIVATE_H
+#define X264_GTK_PRIVATE_H
 
 
 #define __UNUSED__ __attribute__((unused))
@@ -171,4 +171,4 @@
 gchar *x264_gtk_path (const char* more_path);
 
 
-#endif /* __X264_GTK_PRIVATE_H__ */
+#endif /* X264_GTK_PRIVATE_H */
Index: gtk/x264_gtk_i18n.h
===================================================================
--- gtk/x264_gtk_i18n.h	(revision 745)
+++ gtk/x264_gtk_i18n.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef _X264_GTK_I18N_
-#define _X264_GTK_I18N_
+#ifndef X264_GTK_I18N_H
+#define X264_GTK_I18N_H
 
 
 #include <libintl.h>
@@ -8,7 +8,7 @@
 #define _(X) gettext(X)
 #define GETTEXT_DOMAIN "x264_gtk"
 
-#ifdef __X264_GTK_PRIVATE_H__
+#ifdef X264_GTK_PRIVATE_H
 /* x264_path must be known for this to work */
 #  define BIND_X264_TEXTDOMAIN()                        \
   gchar* _tmp = x264_gtk_path("locale");                    \
@@ -21,4 +21,4 @@
 #endif
 
 
-#endif /* _X264_GTK_I18N_ */
+#endif /* X264_GTK_I18N_H */
Index: gtk/x264_gtk_cqm.h
===================================================================
--- gtk/x264_gtk_cqm.h	(revision 745)
+++ gtk/x264_gtk_cqm.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_CQM_H__
-#define __X264_GTK_CQM_H__
+#ifndef X264_GTK_CQM_H
+#define X264_GTK_CQM_H
 
 
 GtkWidget *_cqm_page (X264_Gui_Config *config);
 
 
-#endif /* __X264_GTK_CQM_H__ */
+#endif /* X264_GTK_CQM_H */
Index: gtk/x264_gtk.h
===================================================================
--- gtk/x264_gtk.h	(revision 745)
+++ gtk/x264_gtk.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef __X264_GTK_H__
-#define __X264_GTK_H__
+#ifndef X264_GTK_H
+#define X264_GTK_H
 
 
 #include "x264_gtk_enum.h"
@@ -108,4 +108,4 @@
 void          x264_gtk_free (X264_Gtk *x264_gtk);
 
 
-#endif /* __X264_GTK_H__ */
+#endif /* X264_GTK_H */
Index: gtk/x264_gtk_encode_private.h
===================================================================
--- gtk/x264_gtk_encode_private.h	(revision 745)
+++ gtk/x264_gtk_encode_private.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef __X264_GTK_ENCODE_PRIVATE_H__
-#define __X264_GTK_ENCODE_PRIVATE_H__
+#ifndef X264_GTK_ENCODE_PRIVATE_H
+#define X264_GTK_ENCODE_PRIVATE_H
 
 
 #define __UNUSED__ __attribute__((unused))
@@ -43,4 +43,4 @@
 };
 
 
-#endif /* __X264_GTK_ENCODE_PRIVATE_H__ */
+#endif /* X264_GTK_ENCODE_PRIVATE_H */
Index: gtk/x264_gtk_encode_status_window.h
===================================================================
--- gtk/x264_gtk_encode_status_window.h	(revision 745)
+++ gtk/x264_gtk_encode_status_window.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_ENCODE_STATUS_WINDOW_H__
-#define __X264_GTK_ENCODE_STATUS_WINDOW_H__
+#ifndef X264_GTK_ENCODE_STATUS_WINDOW_H
+#define X264_GTK_ENCODE_STATUS_WINDOW_H
 
 
 GtkWidget *x264_gtk_encode_status_window (X264_Thread_Data *thread_data);
 
 
-#endif /* __X264_GTK_ENCODE_STATUS_WINDOW_H__ */
+#endif /* X264_GTK_ENCODE_STATUS_WINDOW_H */
Index: gtk/x264_gtk_encode_main_window.h
===================================================================
--- gtk/x264_gtk_encode_main_window.h	(revision 745)
+++ gtk/x264_gtk_encode_main_window.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_ENCODE_MAIN_WINDOW_H__
-#define __X264_GTK_ENCODE_MAIN_WINDOW_H__
+#ifndef X264_GTK_ENCODE_MAIN_WINDOW_H
+#define X264_GTK_ENCODE_MAIN_WINDOW_H
 
 
 void x264_gtk_encode_main_window ();
 
 
-#endif /* __X264_GTK_ENCODE_MAIN_WINDOW_H__ */
+#endif /* X264_GTK_ENCODE_MAIN_WINDOW_H */
Index: gtk/x264_gtk_bitrate.h
===================================================================
--- gtk/x264_gtk_bitrate.h	(revision 745)
+++ gtk/x264_gtk_bitrate.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_BITRATE_H__
-#define __X264_GTK_BITRATE_H__
+#ifndef X264_GTK_BITRATE_H
+#define X264_GTK_BITRATE_H
 
 
 GtkWidget *_bitrate_page (X264_Gui_Config *config);
 
 
-#endif /* __X264_GTK_BITRATE_H__ */
+#endif /* X264_GTK_BITRATE_H */
Index: gtk/x264_gtk_demuxers.h
===================================================================
--- gtk/x264_gtk_demuxers.h	(revision 745)
+++ gtk/x264_gtk_demuxers.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef __X264_GTK_MUXERS_H__
-#define __X264_GTK_MUXERS_H__
+#ifndef X264_GTK_MUXERS_H
+#define X264_GTK_MUXERS_H
 
 #include "../config.h"
 #include "../muxers.h"
@@ -15,4 +15,4 @@
 } X264_Demuxer_Type;
 /* static int X264_Num_Demuxers = (int)X264_DEMUXER_UNKOWN; */
 
-#endif  /* __X264_GTK_MUXERS_H__ */
+#endif  /* X264_GTK_MUXERS_H */
Index: gtk/x264_gtk_mb.h
===================================================================
--- gtk/x264_gtk_mb.h	(revision 745)
+++ gtk/x264_gtk_mb.h	(working copy)
@@ -1,8 +1,8 @@
-#ifndef __X264_GTK_MB_H__
-#define __X264_GTK_MB_H__
+#ifndef X264_GTK_MB_H
+#define X264_GTK_MB_H
 
 
 GtkWidget *_mb_page (X264_Gui_Config *config);
 
 
-#endif /* __X264_GTK_MB_H__ */
+#endif /* X264_GTK_MB_H */
Index: common/cabac.h
===================================================================
--- common/cabac.h	(revision 745)
+++ common/cabac.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _CABAC_H
-#define _CABAC_H 1
+#ifndef X264_CABAC_H
+#define X264_CABAC_H
 
 typedef struct
 {
Index: common/frame.h
===================================================================
--- common/frame.h	(revision 745)
+++ common/frame.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _FRAME_H
-#define _FRAME_H 1
+#ifndef X264_FRAME_H
+#define X264_FRAME_H
 
 /* number of pixels past the edge of the frame, for motion estimation/compensation */
 #define PADH 32
Index: common/set.h
===================================================================
--- common/set.h	(revision 745)
+++ common/set.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _SET_H
-#define _SET_H 1
+#ifndef X264_SET_H
+#define X264_SET_H
 
 enum profile_e
 {
Index: common/ppc/dct.h
===================================================================
--- common/ppc/dct.h	(revision 745)
+++ common/ppc/dct.h	(working copy)
@@ -22,8 +22,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _PPC_DCT_H
-#define _PPC_DCT_H 1
+#ifndef X264_PPC_DCT_H
+#define X264_PPC_DCT_H
 
 void x264_sub4x4_dct_altivec( int16_t dct[4][4],
         uint8_t *pix1, uint8_t *pix2 );
Index: common/ppc/predict.h
===================================================================
--- common/ppc/predict.h	(revision 745)
+++ common/ppc/predict.h	(working copy)
@@ -20,9 +20,9 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _ALTIVEC_PREDICT_H
-#define _ALTIVEC_PREDICT_H 1
+#ifndef X264_ALTIVEC_PREDICT_H
+#define X264_ALTIVEC_PREDICT_H
 
 void x264_predict_16x16_init_altivec ( x264_predict_t pf[7] );
 
-#endif // _ALTIVEC_PREDICT_H
+#endif /* X264_ALTIVEC_PREDICT_H */
Index: common/ppc/mc.h
===================================================================
--- common/ppc/mc.h	(revision 745)
+++ common/ppc/mc.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _PPC_MC_H
-#define _PPC_MC_H 1
+#ifndef X264_PPC_MC_H
+#define X264_PPC_MC_H
 
 void x264_mc_altivec_init( x264_mc_functions_t *pf );
 
Index: common/ppc/pixel.h
===================================================================
--- common/ppc/pixel.h	(revision 745)
+++ common/ppc/pixel.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _PPC_PIXEL_H
-#define _PPC_PIXEL_H 1
+#ifndef X264_PPC_PIXEL_H
+#define X264_PPC_PIXEL_H
 
 void x264_pixel_altivec_init( x264_pixel_function_t *pixf );
 
Index: common/ppc/quant.h
===================================================================
--- common/ppc/quant.h	(revision 745)
+++ common/ppc/quant.h	(working copy)
@@ -18,8 +18,8 @@
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/
 
-#ifndef _PPC_QUANT_H
-#define _PPC_QUANT_H 1
+#ifndef X264_PPC_QUANT_H
+#define X264_PPC_QUANT_H
 
 void x264_quant_4x4_altivec( int16_t dct[4][4], uint16_t mf[16], uint16_t bias[16] );
 void x264_quant_8x8_altivec( int16_t dct[8][8], uint16_t mf[64], uint16_t bias[64] );
Index: common/mc.h
===================================================================
--- common/mc.h	(revision 745)
+++ common/mc.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _MC_H
-#define _MC_H 1
+#ifndef X264_MC_H
+#define X264_MC_H
 
 /* Do the MC
  * XXX: Only width = 4, 8 or 16 are valid
Index: common/display.h
===================================================================
--- common/display.h	(revision 745)
+++ common/display.h	(working copy)
@@ -20,8 +20,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _DISPLAY_H
-#define _DISPLAY_H 1
+#ifndef X264_DISPLAY_H
+#define X264_DISPLAY_H
 
 void disp_sync(void);
 void disp_setcolor(unsigned char *name);
Index: common/sparc/pixel.h
===================================================================
--- common/sparc/pixel.h	(revision 745)
+++ common/sparc/pixel.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _SPARC_PIXEL_H
-#define _SPARC_PIXEL_H 1
+#ifndef X264_SPARC_PIXEL_H
+#define X264_SPARC_PIXEL_H
 
 int x264_pixel_sad_8x8_vis( uint8_t *, int, uint8_t *, int );
 int x264_pixel_sad_8x16_vis( uint8_t *, int, uint8_t *, int );
Index: common/cpu.h
===================================================================
--- common/cpu.h	(revision 745)
+++ common/cpu.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _CPU_H
-#define _CPU_H 1
+#ifndef X264_CPU_H
+#define X264_CPU_H
 
 uint32_t x264_cpu_detect( void );
 int      x264_cpu_num_processors( void );
Index: common/quant.h
===================================================================
--- common/quant.h	(revision 745)
+++ common/quant.h	(working copy)
@@ -20,8 +20,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _QUANT_H
-#define _QUANT_H 1
+#ifndef X264_QUANT_H
+#define X264_QUANT_H
 
 typedef struct
 {
Index: common/predict.h
===================================================================
--- common/predict.h	(revision 745)
+++ common/predict.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _PREDICT_H
-#define _PREDICT_H 1
+#ifndef X264_PREDICT_H
+#define X264_PREDICT_H
 
 typedef void (*x264_predict_t)( uint8_t *src );
 typedef void (*x264_predict8x8_t)( uint8_t *src, uint8_t edge[33] );
Index: common/x86/predict.h
===================================================================
--- common/x86/predict.h	(revision 745)
+++ common/x86/predict.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _I386_PREDICT_H
-#define _I386_PREDICT_H 1
+#ifndef X264_I386_PREDICT_H
+#define X264_I386_PREDICT_H
 
 void x264_predict_16x16_init_mmx ( int cpu, x264_predict_t pf[7] );
 void x264_predict_8x8c_init_mmx  ( int cpu, x264_predict_t pf[7] );
Index: common/x86/mc.h
===================================================================
--- common/x86/mc.h	(revision 745)
+++ common/x86/mc.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _I386_MC_H
-#define _I386_MC_H 1
+#ifndef X264_I386_MC_H
+#define X264_I386_MC_H
 
 void x264_mc_init_mmx( int cpu, x264_mc_functions_t *pf );
 
Index: common/x86/dct.h
===================================================================
--- common/x86/dct.h	(revision 745)
+++ common/x86/dct.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _I386_DCT_H
-#define _I386_DCT_H 1
+#ifndef X264_I386_DCT_H
+#define X264_I386_DCT_H
 
 void x264_sub4x4_dct_mmx( int16_t dct[4][4],  uint8_t *pix1, uint8_t *pix2 );
 void x264_sub8x8_dct_mmx( int16_t dct[4][4][4],  uint8_t *pix1, uint8_t *pix2 );
Index: common/x86/pixel.h
===================================================================
--- common/x86/pixel.h	(revision 745)
+++ common/x86/pixel.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _I386_PIXEL_H
-#define _I386_PIXEL_H 1
+#ifndef X264_I386_PIXEL_H
+#define X264_I386_PIXEL_H
 
 #define DECL_PIXELS( ret, name, suffix, args ) \
     ret x264_pixel_##name##_16x16_##suffix args;\
Index: common/x86/quant.h
===================================================================
--- common/x86/quant.h	(revision 745)
+++ common/x86/quant.h	(working copy)
@@ -20,8 +20,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _I386_QUANT_H
-#define _I386_QUANT_H 1
+#ifndef X264_I386_QUANT_H
+#define X264_I386_QUANT_H
 
 void x264_quant_2x2_dc_mmxext( int16_t dct[2][2], int mf, int bias );
 void x264_quant_4x4_dc_mmxext( int16_t dct[4][4], int mf, int bias );
Index: common/bs.h
===================================================================
--- common/bs.h	(revision 745)
+++ common/bs.h	(working copy)
@@ -21,10 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifdef _BS_H
-#warning FIXME Multiple inclusion of bs.h
-#else
-#define _BS_H
+#ifndef X264_BS_H
+#define X264_BS_H
 
 typedef struct bs_s
 {
Index: common/osdep.h
===================================================================
--- common/osdep.h	(revision 745)
+++ common/osdep.h	(working copy)
@@ -18,8 +18,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _OSDEP_H
-#define _OSDEP_H
+#ifndef X264_OSDEP_H
+#define X264_OSDEP_H
 
 #define _LARGEFILE_SOURCE 1
 #define _FILE_OFFSET_BITS 64
@@ -121,4 +121,4 @@
 #define x264_pthread_cond_wait(c,m)  usleep(100)
 #endif
 
-#endif //_OSDEP_H
+#endif /* X264_OSDEP_H */
Index: common/dct.h
===================================================================
--- common/dct.h	(revision 745)
+++ common/dct.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _DCT_H
-#define _DCT_H 1
+#ifndef X264_DCT_H
+#define X264_DCT_H
 
 /* the inverse of the scaling factors introduced by 8x8 fdct */
 #define W(i) (i==0 ? FIX8(1.0000) :\
Index: common/visualize.h
===================================================================
--- common/visualize.h	(revision 745)
+++ common/visualize.h	(working copy)
@@ -20,8 +20,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _VISUALIZE_H
-#define _VISUALIZE_H 1
+#ifndef X264_VISUALIZE_H
+#define X264_VISUALIZE_H
 
 #include "common/common.h"
 
Index: common/macroblock.h
===================================================================
--- common/macroblock.h	(revision 745)
+++ common/macroblock.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _MACROBLOCK_H
-#define _MACROBLOCK_H 1
+#ifndef X264_MACROBLOCK_H
+#define X264_MACROBLOCK_H
 
 enum macroblock_position_e
 {
Index: common/pixel.h
===================================================================
--- common/pixel.h	(revision 745)
+++ common/pixel.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _PIXEL_H
-#define _PIXEL_H 1
+#ifndef X264_PIXEL_H
+#define X264_PIXEL_H
 
 typedef int  (*x264_pixel_cmp_t) ( uint8_t *, int, uint8_t *, int );
 typedef void (*x264_pixel_cmp_x3_t) ( uint8_t *, uint8_t *, uint8_t *, uint8_t *, int, int[3] );
Index: common/common.h
===================================================================
--- common/common.h	(revision 745)
+++ common/common.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _COMMON_H
-#define _COMMON_H 1
+#ifndef X264_COMMON_H
+#define X264_COMMON_H
 
 /****************************************************************************
  * Macros
Index: x264.h
===================================================================
--- x264.h	(revision 745)
+++ x264.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _X264_H
-#define _X264_H 1
+#ifndef X264_X264_H
+#define X264_X264_H
 
 #if !defined(_STDINT_H) && !defined(_STDINT_H_) && \
     !defined(_INTTYPES_H) && !defined(_INTTYPES_H_)
Index: matroska.h
===================================================================
--- matroska.h	(revision 745)
+++ matroska.h	(working copy)
@@ -21,8 +21,8 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
  *****************************************************************************/
 
-#ifndef _MATROSKA_H
-#define _MATROSKA_H 1
+#ifndef X264_MATROSKA_H
+#define X264_MATROSKA_H
 
 typedef struct mk_Writer mk_Writer;
 
Index: muxers.h
===================================================================
--- muxers.h	(revision 745)
+++ muxers.h	(working copy)
@@ -1,5 +1,5 @@
-#ifndef _X264_MUXERS_H_
-#define _X264_MUXERS_H_
+#ifndef X264_MUXERS_H
+#define X264_MUXERS_H
 
 typedef void *hnd_t;
 